program Rn;
{ Kovcs Z., 2002/03/15 }

{ A bemenet (Rn.be) els sorban n rtke ll, a msodikban egy permutci,
  ami a Cayley-tbla felrst befolysolja. Pl.:
  
  15
  1 2 3 4 5 6 7 8
  
  jelentse: R15-ben az identikus permutci szerinti Cayley-tblt krjk. }

uses CRT;
const
    maxM=8;
    szin: array[1..maxM] of integer=(0,1,2,3,4,5,6,7);
    szelesseg=2; { egy rubrika hny karakter szles legyen }
    magassag=1; { egy rubrika hny karakter magas legyen }

var n: integer;
    M: integer; { fi(n) }
    p,e: array[1..maxM] of integer; { permutci, Rn elemei }

function max(a,b: integer): integer;
begin
    if a<b then max:=b else max:=a;
    end;
    
function min(a,b: integer): integer;
begin
    if a>b then min:=b else min:=a;
    end;

function lnko(a,b: integer): integer;
var c,d: integer;
begin
    c:=min(a,b);
    d:=max(a,b);
    if c=0 then lnko:=d else begin
	a:=d mod c;
	lnko:=lnko(a,c);
	end;
    end;

procedure M_e_feltoltese;
var i: integer;
begin
    M:=0;
    for i:=1 to n-1 do
	if lnko(i,n)=1 then begin
	    if M>maxM then begin
		writeln('Rn: fi(n) tl nagy (legfeljebb ',maxM,' lehet)');
		halt(1);
		end;
	    M:=M+1;
	    e[M]:=i;
	    end;
    end;
  
procedure beolvas;
var f: text;
    i: integer;
begin
    assign(f,'Rn.be');
    reset(f);
    readln(f,n);
    M_e_feltoltese;
    for i:=1 to M do
	read(f,p[i]);
    close(f);
    end;

function index(a: integer): integer;
{ megadja, hogy egy "a" Rn-beli szm sorrendben hnyadik legkisebb elem }
var i: integer;
begin
    i:=1;
    while e[i]<>a do
	i:=i+1;
    index:=i;
    end;

function p_inv(a: integer): integer;
{ p inverzt adja vissza az "a" helyen }
var i: integer;
begin
    i:=1;
    while p[i]<>a do
	i:=i+1;
    p_inv:=i;
    end;

procedure jelmagyarazat;
var i,k,l: integer;
begin
    for i:=1 to M do begin
	gotoXY((M+3)*szelesseg+1,i*magassag);
	write(e[p[i]]);
	textbackground(szin[i]);
	for k:=0 to szelesseg-1 do
	    for l:=0 to magassag-1 do begin
		gotoXY((M+2)*szelesseg+k,i*magassag+l);
		write(' ');
		end;
	textbackground(black);
	end;
    end;

procedure Cayley_tabla;
var i,j,k,l,szorzat: integer;
begin
    for i:=1 to M do
	for j:=1 to M do begin
	    szorzat:=e[p[i]]*e[p[j]] mod n;
	    textbackground(szin[p_inv(index(szorzat))]);
	    for k:=0 to szelesseg-1 do
		for l:=0 to magassag-1 do begin
	    	    gotoXY(j*szelesseg+k,i*magassag+l);
		    write(' ');
		    end;
	    end;
    textbackground(black);
    writeln;
    end;

begin
    beolvas;
    clrscr;
    jelmagyarazat;
    Cayley_tabla;
    end.